aboutsummaryrefslogtreecommitdiff
path: root/bin
diff options
context:
space:
mode:
authorEuAndreh <eu@euandre.org>2023-08-27 16:24:38 -0300
committerEuAndreh <eu@euandre.org>2023-08-27 16:24:38 -0300
commit2b2d65d9a1e30944448af17ddc4f90b3f3758dab (patch)
tree954ce8e69319141c09f82c67720d9e473800131c /bin
parentetc/guix/system.scm: Add local nginx server (diff)
downloaddotfiles-2b2d65d9a1e30944448af17ddc4f90b3f3758dab.tar.gz
dotfiles-2b2d65d9a1e30944448af17ddc4f90b3f3758dab.tar.xz
bin/muffle: Add new working utility
Diffstat (limited to 'bin')
-rwxr-xr-xbin/muffle79
1 files changed, 79 insertions, 0 deletions
diff --git a/bin/muffle b/bin/muffle
new file mode 100755
index 0000000..73c9103
--- /dev/null
+++ b/bin/muffle
@@ -0,0 +1,79 @@
+#!/bin/sh
+set -eu
+
+usage() {
+ cat <<-'EOF'
+ Usage:
+ muffle [--] COMMAND...
+ muffle -h
+ EOF
+}
+
+help() {
+ cat <<-'EOF'
+
+
+ Options:
+ -h, --help show this message
+
+ COMMAND the COMMAND to be muffled
+
+
+ Conditionally omit STDOUT and STDERR of COMMAND:
+ if command exits with an error, print its original output to the
+ corresponding streams, but when there is no error, throw the
+ output away, "muffling" the COMMAND.
+
+
+ Examples:
+
+ Only print anything if the test fails:
+
+ $ muffle sh tests/assert-makefile.sh
+ EOF
+}
+
+
+for flag in "$@"; do
+ case "$flag" in
+ (--)
+ break
+ ;;
+ (--help)
+ usage
+ help
+ exit
+ ;;
+ (*)
+ ;;
+ esac
+done
+
+while getopts 'h' flag; do
+ case "$flag" in
+ (h)
+ usage
+ help
+ exit
+ ;;
+ (*)
+ usage >&2
+ exit 2
+ ;;
+ esac
+done
+shift $((OPTIND - 1))
+
+
+OUT="$(mkstemp)"
+ERR="$(mkstemp)"
+trap 'rm -f "$OUT" "$ERR"' EXIT
+
+STATUS=0
+"$@" 1>"$OUT" 2>"$ERR" || STATUS=$?
+
+if [ "$STATUS" != 0 ]; then
+ cat "$OUT"
+ cat "$ERR" >&2
+ exit "$STATUS"
+fi